/************************************************************************/
/* Projekt : "lc1116a.dll" - biblioteka DLL WINDOWS dla karty LC-012-1612 */
/* Autor : Krzysztof Mroczek 	  1996                                        */
/************************************************************************/
#define  STRICT
#include <windows.h>
#pragma hdrstop
#define _EXPORT _export
#include  <toolhelp.h>
#include  <dos.h>
#include  "lc012.h"
#include  "lc012int.h"


extern CModuleData *ModWsk[4]	;

///////////////////////////////////////////////////////////////////////////
// CTC_WRITE
// Funkcja LC0_CTCWrite :
// Zapis bajtu programujcego oraz wartoci pocztkowej do licznika CTC
// do wykorzystania przez user'a . Jest zaimplementowany tryb pracy
// Read Back Mode : dziala to tylko dla ukladu 8254 .
// Parametry wejsciowe :
//  param : daleki wskanik do rekordu z parametrami wejciowymi i
//  statusu .
//////////////////////////////////////////////////////////////////////////
extern "C"  void FAR PASCAL _export LC0_CTCWrite(lc0_ctc_write FAR *param)
{
	char errcode ;
	unsigned char par , p,val,val1;
	unsigned int badr,adr1,adr2;

	param->LC0_ERR_STAT = LC0_E_OK		  ;
	param->LC0_STATUS = LC0_OK;
	if((param->LC0_CMODULE >= LC0_MODA) && (param->LC0_CMODULE <= LC0_MODD))
	 {
		errcode = ModWsk[(param->LC0_CMODULE) -1 ]->CheckApp();
		if(errcode!=LC0_OK)
		 {
			param->LC0_STATUS = errcode;
			return;
		 }

		if((param->LC0_CMODE & 0x03) == 0x00 )
		 {
		  param->LC0_STATUS = LC0_BAD_CTC_MODE ;
		  return;
		 }

		  p=param->LC0_CFUN & 0x0c ; //M2,M1,M0
		  if(p==0x0c)
			param->LC0_STATUS = LC0_BAD_CTC_MODE ;

		  p=param->LC0_CFUN & 0x30 ;
		  if(p==0)
			param->LC0_STATUS = LC0_BAD_CTC_MODE ;
		  ModWsk[(param->LC0_CMODULE) -1 ]->RWCTCMode = p >> 4;

		  p=param->LC0_CFUN & 0xC0 ;
		  if((p==0x80) || (p==0x00))
			param->LC0_STATUS = LC0_NONEX_DEV ;
		  if(p==0xC0)
			 ModWsk[(param->LC0_CMODULE) -1 ]->RBCTCMode = 1;
		  else
			 ModWsk[(param->LC0_CMODULE) -1 ]->RBCTCMode = 0;
		  if(param->LC0_STATUS != LC0_OK)
			return;
	 }
	else
	 {
		param->LC0_STATUS = LC0_NO_MODULE ;
		return ;
	 }

	 badr = ModWsk[(param->LC0_CMODULE) -1 ]->BaseAdr;
	 adr1= badr+ACTC2+3;
	 adr2 = badr+ACTC2+1 ;
	 if((param->LC0_CMODE & 0x01)!=0 )
	  {
		val = param->LC0_CFUN  ;
		outportb(adr1,val);
		if((param->LC0_CFUN & 0xC0) != 0xC0)
		 ModWsk[(param->LC0_CMODULE) -1 ]->IsCTCProg = 1;
		else
		 ModWsk[(param->LC0_CMODULE) -1 ]->IsCTCProg = 2;
	  }
	 if(((param->LC0_CMODE & 0x02)!=0 )&&
	 (ModWsk[(param->LC0_CMODULE) -1 ]->RBCTCMode == 0) )
	  {
		//czy by zaprogramowany tryb pracy
		if(ModWsk[(param->LC0_CMODULE) -1 ]->IsCTCProg ==0)
		 {
		  param->LC0_STATUS = LC0_CTC_NOT_PROGRAMMED ;
		  return ;
		 }

		val = (unsigned char)(param->LC0_CVAL & 0x00ff);
		outportb(adr2,val);
		if(ModWsk[(param->LC0_CMODULE) -1 ]->RWCTCMode == 3)
		 {
		  val1 = (unsigned char)(param->LC0_CVAL >> 8);
		  outportb(adr2,val1);
		 }

		ModWsk[(param->LC0_CMODULE) -1 ]->IsCTCProg = 2;
	  }
}



//////////////////////////////////////////////////////////////////////////
// CTC_READ
// Funkcja LC0_CTCRead :
// Odczyt wartoci kanau CTC uytkownika , wczeniej zaprogramowego .
// Jest rwnie oprogramowany tryb Read Back Mode : odczyt bajtu statusu
// ukadu (tylko 8254) po wczeniejszym zapisie za pomoc funkcji
// LC0_CTCWrite bajtu ReadBackMode .
// Parametry wejciowe :
//  param : daleki wskanik do rekordu z parametrami wejciowymi i statusu
//////////////////////////////////////////////////////////////////////////
extern "C"  void FAR PASCAL _export LC0_CTCRead(lc0_ctc_read FAR *param)
{
 char errcode ;
 unsigned char val1,val2=0;
 unsigned int badr,adr1,adr2;

	param->LC0_ERR_STAT = LC0_E_OK		  ;
	param->LC0_STATUS = LC0_OK ;
	if((param->LC0_UMODULE >= LC0_MODA) && (param->LC0_UMODULE <= LC0_MODD))
	 {
		errcode= ModWsk[(param->LC0_UMODULE) -1 ]->CheckApp();

	 }
	else
	 {
		param->LC0_STATUS = LC0_NO_MODULE ;
		return ;
	 }
	if(errcode == LC0_OK)
	 {

	  badr = ModWsk[(param->LC0_UMODULE) -1 ]->BaseAdr;
	  if((param->LC0_UNUM > CTC_NUM) || (param->LC0_UNUM ==0) )
		{
		 param->LC0_STATUS = LC0_NONEX_DEV ;
		 return;
		}

	  if(ModWsk[(param->LC0_UMODULE) -1 ]->IsCTCProg != 2)
		 {
		  param->LC0_STATUS = LC0_CTC_NOT_PROGRAMMED ;
		  return ;
		 }

	  adr1 = badr+ACTC2+3;
	  adr2 = badr+ACTC2+(param->LC0_UNUM);

	  if(ModWsk[(param->LC0_UMODULE) -1 ]->RBCTCMode ==0)
		{
		 val1 = (param->LC0_UNUM)<<6;
		 outportb(adr1,val1);
		}
	  val1 = inportb(adr2);
	  if(ModWsk[(param->LC0_UMODULE) -1 ]->RWCTCMode ==3)
		val2=inportb(adr2);
	  param->LC0_UVAL = val1 + (val2<<8);
	 }
	else
	 param->LC0_STATUS = errcode ;
}


