/************************************************************************/
/* Projekt : "lc1116a.dll" - biblioteka DLL WINDOWS dla karty LC-012-1612 */
/* Autor : Krzysztof Mroczek 	 1996                                      */
/************************************************************************/
#define  STRICT
#include <windows.h>
#pragma hdrstop
#define _EXPORT _export
#include  <toolhelp.h>
#include  <dos.h>
#include  "lc012.h"
#include  "lc012int.h"
extern CModuleData *ModWsk[4]	;

///////////////////////////////////////////////////////////////////////////
// DIGITAL_INPUT
// Funkcja LC0_DigitalIn :
//  Odczyt bajtu z wybranego portu cyfrowego karty :
//  Dziaaj parametry startu
// Parametry wejciowe :
//  param : daleki wskanik do struktury 'lc0_digital_in' z parametrami
//  wywoania i statusu .
///////////////////////////////////////////////////////////////////////////
extern "C"  void FAR PASCAL _export LC0_DigitalIn(lc0_digital_in FAR *param)
{
 char errcode , errex;
 unsigned char par[5] ,*ptr;
 unsigned long ptime ;
 unsigned int np,ii;

 param->LC0_ERR_STAT = LC0_E_OK		  ;
 param->LC0_STATUS = LC0_OK ;
 if((param->LC0_DMODULE >= LC0_MODA) && (param->LC0_DMODULE <= LC0_MODD))
  {
	errcode = ModWsk[(param->LC0_DMODULE) -1 ]->CheckApp();

	if(errcode != LC0_OK)
	 {
		param->LC0_STATUS = errcode ;
		return ;
	 }
  }
 else
  {
	param->LC0_STATUS = LC0_NO_MODULE ;
	return ;
  }

 if((param->LC0_DNUM == 0) || ((param->LC0_DNUM >3) ) )
  {
	 param->LC0_STATUS = LC0_NONEX_DEV ;
	 return ;
  }

 ptr = (unsigned char *)(&(param->LC0_DSTART));
 for(ii=0;ii<5;ii++)
  par[ii]=*(ptr+ii);
 ptime = param->LC0_DSTART.time ;

  errcode = WaitForStart(param->LC0_DSTST ,par,ptime ,&errex,param->LC0_DMODULE,1);
  if(errcode!=LC0_OK) //by bd
	{
	  param->LC0_STATUS = errcode ;
	  param ->LC0_ERR_STAT = errex ;
	  return ;
	}

  int pid ;
  pid = ModWsk[(param->LC0_DMODULE) - 1]->BaseAdr ;
  switch(param->LC0_DNUM)
	{
	  case	1	:np = 12;
					 break;
	  case	2	:np = DIG_IN_1	;
					 break;
	  case	3	:np = DIG_IN_2	;
					 break;
	};
  param->LC0_DVAL = inportb(pid + np);
  if(param->LC0_DNUM == 1)
	param->LC0_DVAL &= 0x0f ;
}

////////////////////////////////////////////////////////////////////////////
// DIGITAL_OUTPUT
// Funkcja LC0_DigitalOut :
//  Zapis bajtu do wybranego portu cyfrowego moduu :
//  Diaaj parametry startu .
// Parametry wejciowe :
//  param : daleki wskanik do struktury 'lc0_digital_out' z parametrami
//  wywoania i statusu .
////////////////////////////////////////////////////////////////////////////
extern "C"  void FAR PASCAL _export LC0_DigitalOut(lc0_digital_out FAR *param)
{
 char errcode , errex;
 unsigned char par[5] ,*ptr;
 unsigned long ptime ;
 unsigned int np,ii;

 param->LC0_ERR_STAT = LC0_E_OK		  ;
 param->LC0_STATUS = LC0_OK ;
 if((param->LC0_OMODULE >= LC0_MODA) && (param->LC0_OMODULE <= LC0_MODD))
  {
	errcode = ModWsk[(param->LC0_OMODULE) -1 ]->CheckApp();
	if(errcode != LC0_OK) //jest bd
	 {
		param->LC0_STATUS = errcode ;
		return ;
	 }
  }
 else
  {
	param->LC0_STATUS = LC0_NO_MODULE ;
	return ;
  }

 if((param->LC0_ONUM == 0) || (param->LC0_ONUM >3) ) //bd
  {
	 param->LC0_STATUS = LC0_NONEX_DEV ;
	 return ;
  }

 ptr = (unsigned char *)(&(param->LC0_OSTART));
 for(ii=0;ii<5;ii++)
  par[ii]=*(ptr+ii);
 ptime = param->LC0_OSTART.time ;


  errcode = WaitForStart(param->LC0_OSTST ,par,ptime ,&errex,param->LC0_OMODULE,1);

  if(errcode!=LC0_OK)
	{
	  param->LC0_STATUS = errcode ;
	  param ->LC0_ERR_STAT = errex ;
	  return ;
	}

  int pid , oval;
  pid = ModWsk[(param->LC0_OMODULE) - 1]->BaseAdr ;
  oval = param->LC0_OVAL ;
  switch(param->LC0_ONUM)
	{
	  case	1	:np = 13;
					 oval = param->LC0_OVAL & 0x0f ;
					 ModWsk[(param->LC0_OMODULE) - 1]->PSTS2 &= 0xf0 ;
					 ModWsk[(param->LC0_OMODULE) - 1]->PSTS2 |= oval ;
					 oval = ModWsk[(param->LC0_OMODULE) - 1]->PSTS2 ;
					 break;
	  case	2	:np = DIG_OUT_1	;
					 break;
	  case	3	:np = DIG_OUT_2	;
					 break;

	};
  outportb(pid+np,oval);
}
