/* ****************************************************************** */
/* Projekt : biblioteka DLL "lc1116a.dll" dla karty LC-012-1612			 */
/* s****************************************************************** */
/* Plik implementacyjny wewntrzny LC1216a.dll								 */
/* Header  : "lc012int.h"															 */
/* Autor : Krzysztof Mroczek , 1996                                   */
/**********************************************************************/
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <dir.h>
#include <time.h>
#include "lc012.h"
#include "lc012int.h"
extern CModuleData *ModWsk[4]	; //tablica wskaza do obiektw moduw A,B,C,D
extern global GData					; //globalne dane o moduach
extern HINSTANCE	DLLInst			; // parametr wywoania LibMain
extern WORD		DLLDseg			; // ~
extern WORD      DLLHeap			; // ~

extern struct CModuleData *ModPtrAC;
//extern struct WaitForEndParam WEPCA;
extern struct CModuleData *ModPtrCA;
/////////////////////////////////////////////////////////////////////
 unsigned char maska[]={1,2,4,8,16,32,64,128};
 #define INIKEYGLOB	 3			/* ilo parametrw globalnych w pliku .INI */
 #define INITKEYMOD	 14		/* ilo parametrw dot. moduw w pliku .INI*/
 char config_file[MAXPATH];		/* plik konfiguracyjny */
 char ini_file[]="AMBEX.INI";
 char *SectionTerm = "[LC-";            /* nagwek sekcji dla nowej karty*/
 //////////////////////////////////////////////////////////////////////////
 // nazwy poszczeglnych parametrw z pliku AMBEX.ini
 ///////////////////////////////////////////////////////////////////////////

 char *IniKeyGlob[] =   {
								"PATH",
								"INTTIME",
								"MODULES"
							  };   // STRINGI GLOBALNE DLA LC-012-1612
 char *IniKeyMod[]	 = {
							 "AD_CONVERTER",
							 "AD_CONVTIME",
							 "AD_CONVTABLE",
							 "EXTMEMBUFFER",
							 "MODE",
							 "CLKFREQUENCY",
							 "IRQNUMBER",
							 "DA_CHANNELS",
							 "AD_VMIN",
							 "AD_VMAX",
							 "AD_DMANUMBER",
							 "DA1_VMIN",
							 "DA1_VMAX",
							 "DA2_VMIN",
							 "DA2_VMAX",
							 "DA_DMANUMBER",
							 "DA_CONVTABLE",
							};  //STRINGI MODUOWE DLA LC-012-1612
///////////////////////////////////////////////////////////////////////////
// implementacja klasy zarzdzajacej poszczeglnymi moduami
///////////////////////////////////////////////////////////////////////////
/*
 Konstruktor
 Parametry wejciowe :
  BaseAdres - adres bazowy urzdzenia
*/
CModuleData::CModuleData(unsigned int BaseAdres)
 {
	IsInit	= FALSE					;
	IsLoaded = FALSE					;
	InitError = LC0_OK;
	IsIRQProc = FALSE	;
	IsAsyncOpAC	 = 0					;
	IsAsyncOpCA = 0 ;
	AsyncEnable = 1					;
	SynEnable	 = 0					;
	BreakProc = NULL					;
	ACValid = FALSE					;
	CAValid = FALSE					;
	BaseAdr	= BaseAdres				;
	PSTS2		= 0xbf					;
	POSTS1	= 0xff					;
	hexmem = NULL ; ptrex = NULL;
	ExSize = 0;
	InExSize = 0 ; //z pliku ini
	PAC.DevBusy = FALSE ;
	PCA.DevBusy = FALSE ;
	IsCTCProg =0;
	RWCTCMode = 3; //LSB i MSB
	PAC.CTCLong= 0x10101010;
	PAC.CTCWord1=0x1010;
	PAC.CTCWord2=0x1010;
	IsConvtable=0;
 }
//////////////////////////////////////////////////////////////////////
// Metoda ->Exit()
// czyszczenie strujtury danych z informacjami o module
//////////////////////////////////////////////////////////////////////
 void::CModuleData::Exit()
 {
	IsInit = FALSE ;
	IsAsyncOpAC = 0					;
	IsAsyncOpCA = 0					;
	AsyncEnable = 1					;
	SynEnable	 = 0					;
	BreakProc = NULL					;
	ACValid =FALSE;
	CAValid = FALSE;
	hexmem = NULL ; ptrex = NULL;
	ExSize = 0;
	IsIRQProc = FALSE ;
 }

//////////////////////////////////////////////////////////////////////
// destruktor
//////////////////////////////////////////////////////////////////////
CModuleData::~CModuleData()
 {
	IsLoaded = FALSE		;
	InitError=LC0_OK;
	Exit();
 }

//////////////////////////////////////////////////////////////////////
// Metoda ->CheckApp()
//sprawdzenie statusu zadania odwoujcego si do moduu
// rezultat : kod bdu lub LC0_OK
//////////////////////////////////////////////////////////////////////
int CModuleData::CheckApp()
 {
	HTASK		 hTask ;
	if(InitError==LC0_BAD_CONFIG)
	 return(LC0_BAD_CONFIG);
	if(!IsLoaded)
	 return(LC0_NO_MODULE);
	if(!IsInit)
	 return LC0_NOT_INIT ;
	hTask = ::GetCurrentTask();
	if(hTask != AppTask)
	  return	LC0_REJECTED ;
	return LC0_OK ;
 }

///////////////////////////////////////////////////////////////////
// Metoda ->CheckModule()
// sprawdza czy rzeczywiscie jest zainstalowany modu
// poprzez badanie istnienia kanau CTC kanal 0
// rezultat : kod bedu lub LC0_OK
///////////////////////////////////////////////////////////////////
char CModuleData::CheckModule()
{
 unsigned char val1 ;
 int period = 30000 ;
 int i;
 char err = LC0_NO_MODULE ;

		outportb(BaseAdr+ACTC1+3,0x34);
		outportb(BaseAdr+ACTC1,0x10);
		outportb(BaseAdr+ACTC1,0x10);

		outportb(BaseAdr+ACTC1+3,0x74);
		outportb(BaseAdr+ACTC1+1,0x10);
		outportb(BaseAdr+ACTC1+1,0x10);
		outportb(BaseAdr+ACTC2+3,0xb4);
		outportb(BaseAdr+ACTC2+2,0x0f);
		outportb(BaseAdr+ACTC2+2,0x00);
		val1=0x0e ;

		outportb(BaseAdr+ASTS1_W,val1) ; //blokada CTC,DMA,single
		outportb(BaseAdr+AMUX_W,1);
		inportb(BaseAdr+AEN_BLOK_R) ;

		outportb(BaseAdr+AADC_W,0);
		outportb(BaseAdr+AADC_W,0);
		for(i=0;i<period;i++)
		 {
		  if((inportb(BaseAdr+ASTS1_R) & 0x80)==0)
			{
				inportb(BaseAdr+AADC_R);
				inportb(BaseAdr+AADC_R);
				err = LC0_OK ;
				break ;
			}
		 }
	  Reset();

  return(err);
}

//////////////////////////////////////////////////////////////////////
// Metoda ->Reset()
//reset sprztowy karty
//////////////////////////////////////////////////////////////////////
void CModuleData::Reset() //resetuje kart
  {
	 POSTS1 &= 0x7f ;
	 outportb(BaseAdr + 12 , POSTS1) ;
	 POSTS1 |= 0x80 ;
	 outportb(BaseAdr + 12 , POSTS1) ;
	 POSTS1 &= 0x7f ;
	 outportb(BaseAdr + 12 , POSTS1) ;
  }

////////////////////////////////////////////////////////////////////////
// Metoda ->ClearCard()
// inicjacja pocztkowa karty przy MODULE_INIT - reset
////////////////////////////////////////////////////////////////////////
void CModuleData::ClearCard()
{
 Reset();
 POSTS1 = 0x0e ;
 outportb(BaseAdr + 12,POSTS1);

 PSTS2 = 0xbf ;
 outportb(BaseAdr + 13,PSTS2);

 outportb(BaseAdr + 16 , 0x00) ;
 CTCInitWrite();
 outportb(BaseAdr+3,0x34);
 outportb(BaseAdr,0x10)	;
 outportb(BaseAdr,0x10)	;
 outportb(BaseAdr+3,0x74);
 outportb(BaseAdr+1,0x10);
 outportb(BaseAdr+1,0x10);
 outportb(BaseAdr+3,0xb4);
 outportb(BaseAdr+2,0x10);
 outportb(BaseAdr+2,0x10);
 Reset();
}

/////////////////////////////////////////////////////////////////////////////
// Metoda ->ClearDACs()
// zerowanie przetwornikow C/A podczas pierwszego ladowania biblioteki
// do pamieci
/////////////////////////////////////////////////////////////////////////////
void CModuleData::ClearDACs()
{
 if(CA1_V1 >=0)
  {
	outportb(BaseAdr+24,0x00);	outportb(BaseAdr+24,0x00);
  }
 else
  {
	outportb(BaseAdr+24,0x00);	outportb(BaseAdr+24,0x08);
  }
 if(CA2_V1 >=0)
  {
	outportb(BaseAdr+28,0x00);	outportb(BaseAdr+28,0x00);
  }
 else
  {
	outportb(BaseAdr+28,0x00); outportb(BaseAdr+28,0x08);
  }
}


///////////////////////////////////////////////////////////////////////
// Metoda ->ResetCTC()
// ustawienie CTC w przypadku pracy wielokanaowej
///////////////////////////////////////////////////////////////////////
void CModuleData::ResetCTC()
{
  POSTS1 &= 0x7f ;
  outportb(BaseAdr + 12 , POSTS1) ;
  POSTS1 |= 0x80 ;
  outportb(BaseAdr + 12 , POSTS1) ;
  inportb(BaseAdr+IN_EXTRA_R);
  POSTS1 &= 0x7f ;
  outportb(BaseAdr + 12 , POSTS1) ;
}

//////////////////////////////////////////////////////////////////////
// Metoda ->MessageBreak()
//wywoanie funkcji obsugi BREAK
//////////////////////////////////////////////////////////////////////
void CModuleData::MessageBreak()
 {
	HWND hwnd;
	if(BreakProc==NULL)
	 {
	  ::MessageBeep(-1);
	  hwnd = ::GetActiveWindow();
	  ::MessageBox(hwnd,"LC1216A.DLL dialog box : LC0_BREAK_EXEC","LC-012-1612 Info",MB_OK);
	 }
	else
	 (*BreakProc)();
 }
/////////////////////////////////////////////////////////////////////
// Metoda ->CTCInitWrite()
// programowanie CTC karty
//////////////////////////////////////////////////////////////////////
void CModuleData::CTCInitWrite()
{
 outportb(BaseAdr+3,0x34)	;
 outportb(BaseAdr+3,0x74)	;
 outportb(BaseAdr+7,0x32)	;
 outportb(BaseAdr+4,0x18)	;
 outportb(BaseAdr+4,0x00)  ;

 outportb(BaseAdr+7,0x72)	;
 outportb(BaseAdr+5,0x18)	;
 outportb(BaseAdr+5,0x00)  ;

 outportb(BaseAdr+7,0xb4)	;
 outportb(BaseAdr+6,0x10)	;
 outportb(BaseAdr+6,0x00)	;

}

///////////////////////////////////////////////////////////////////////////////
// Metoda ->AllocExtMem()
// Alokacja bufora pamici rozszerzonej EXTMEM DLL dla aplikacji
// Rezultat :
// LC0_OK lub kod bdu
///////////////////////////////////////////////////////////////////////////////
char CModuleData::AllocExtMem()
{
  BOOL er=FALSE;

  if(ExMem != 0) //jest yczenie
	{
	 hexmem = ::GlobalAlloc(GMEM_MOVEABLE|GMEM_NODISCARD|GMEM_NOCOMPACT|
	 GMEM_LOWER,InExSize);
	 if(hexmem!=NULL)
	  {
		ptrex = (int huge *)(::GlobalLock(hexmem));
		if(ptrex==NULL)
		 er=TRUE;
	  }
	 else
	  {
		er=TRUE;
	  }

	 if(er)
		{
		 hexmem = NULL ; ptrex = NULL;
		 ExSize = 0;
		}
	 else
	  ExSize = InExSize ;
	}
  else
	{
	 hexmem = NULL ; ptrex = NULL;ExSize = 0;
	}
  return LC0_OK ;
}

/////////////////////////////////////////////////////////////////////////
// Metoda ->FreeExtMem()
// Zwolnienie bufora pamici rozszerzonej DLL
/////////////////////////////////////////////////////////////////////////
void CModuleData::FreeExMem()
{
 if((ExMem!=0) && (hexmem != NULL) && (ptrex !=NULL) )
  {
	::GlobalUnlock(hexmem);
	::GlobalFree(hexmem) ;
	ptrex = NULL ; hexmem = NULL;
	ExSize = 0 ;
  }
}

//////////////////////////////////////////////////////////////////////////
// Metoda ACMeasure()
// pomiar czasw konwersji i wypenienie tablicy minimalnych czasw konwersji
// A/C .
// parametry wejciowe :
//  mod - nr moduu dla ktrego odbywa si sprawdzanie
// Rezultat LC0_OK lub kod bdu
//////////////////////////////////////////////////////////////////////////
lc0_analog_in SAnalogIn;
int Buffer[160]; //bufor na prbki

void ACMeasure(unsigned char mod) //1..4
{
 int i,chan,ok=0;
 unsigned long T;//w 0.1 us
 BOOL f1=FALSE , f2=FALSE;
  if(ModWsk[mod-1]->IsConvtable!=0)
	return;
  //akcja
  T=ModWsk[mod-1]->Tconv/100;
  for(i=0;i<AC_CHANNELS;i++)
	 ModWsk[mod-1]->STable[i]=(unsigned int)((unsigned int)T*(i+1));

  SAnalogIn.LC0_CODE=ANALOG_INPUT;SAnalogIn.LC0_AMODULE=mod;
  SAnalogIn.LC0_ANUM=1;
  SAnalogIn.LC0_AMODE=LC0_MOD_START | LC0_MOD_NEW_PAR | LC0_MOD_SYNCHR | LC0_MOD_BLOCK;
  SAnalogIn.LC0_ASTST = 0 ;
  SAnalogIn.LC0_APER=T ;
  SAnalogIn.LC0_ACHAN = 0x81 ;
  SAnalogIn.LC0_AADDR=(int far *)Buffer;
  SAnalogIn.LC0_ALEN=160;

  SAnalogIn.LC0_APER=5000;//0.5 ms
  SAnalogIn.LC0_ASTOP.samples=8;
  //3-razy
  for(i=0;i<3;i++)
	{
	 LC0_AnalogIn(&SAnalogIn);
	 if(SAnalogIn.LC0_STATUS==LC0_OK)
	  {
		 f1=TRUE;
		 break;
	  }
	}

  if(f1==FALSE) //bd DMA lub inny
	{
	 ModWsk[mod-1]->AC_DMA = 0xff ;
	 return ;
	}
  else
	{
	 SAnalogIn.LC0_APER=10000;
	 SAnalogIn.LC0_ASTOP.samples=8;
	 SAnalogIn.LC0_ACHAN = 0x04 ;
	 for(i=0;i<3;i++)
	  {
		LC0_AnalogIn(&SAnalogIn);
		if(SAnalogIn.LC0_STATUS==LC0_OK)
		 {
		  f2=TRUE;
		  break;
		 }
	  }
	}


 SAnalogIn.LC0_ACHAN = 0x81 ; //pr. 1-o kanaowa
 SAnalogIn.LC0_ASTOP.samples=8;
 do
  {
	SAnalogIn.LC0_APER=T;
	LC0_AnalogIn(&SAnalogIn);
	if(SAnalogIn.LC0_STATUS==LC0_OK)
	 {
		ok=1;
		for(i=0;i<3;i++)
		 {
		  LC0_AnalogIn((lc0_analog_in FAR *)&SAnalogIn);
		  if(SAnalogIn.LC0_STATUS!=LC0_OK)
			{
			 ok=0;
			 break;
			}
		 }
	 }

	if(ok==0)
	 T+=5;
	if(T>4*ModWsk[mod-1]->STable[0])
	 return ;
  }while(ok==0);
 ModWsk[mod-1]->STable[0]=(unsigned int)T;
 for(i=1;i<AC_CHANNELS;i++)
  ModWsk[mod-1]->STable[i]=(unsigned int)((unsigned int)T*(i+1));

 if(f2==FALSE)
  return;
 //////////////////////////////////////////////////////////////////////////
 // pomiar wielokanaowy
 //////////////////////////////////////////////////////////////////////////
 for(chan=2;chan<=AC_CHANNELS;chan++)
  {
	T=ModWsk[mod-1]->STable[chan-1]-20; //-2us karencji
	SAnalogIn.LC0_ASTOP.samples=chan*3;
	SAnalogIn.LC0_ACHAN = chan ;
	ok=0;
	do
	 {
	  SAnalogIn.LC0_APER=T;
	  LC0_AnalogIn((lc0_analog_in FAR *)&SAnalogIn);
	  if(SAnalogIn.LC0_STATUS==LC0_OK)
		{
		 ok=1;
		 for(i=0;i<3;i++)
		 {
		  LC0_AnalogIn((lc0_analog_in FAR *)&SAnalogIn);
		  if(SAnalogIn.LC0_STATUS!=LC0_OK)
			{
			 ok=0;
			 break;
			}
		 }
		}

		if(ok==0)
		T+=5;
	  if(T>4000)
		T-=1;
	  if(T>4*ModWsk[mod-1]->STable[chan-1])
		return ; //bd nieznany overrun - wyskok
	 }while(ok==0);
	ModWsk[mod-1]->STable[chan-1]=(unsigned int)T;
  }
}

//######################################################################
////////////////////////////////////////////////////////////////////////
// funkcje wewntrzne do odczytu konfiguracji z pliku konfiguracyjnego
////////////////////////////////////////////////////////////////////////
//#######################################################################

/*
 Funkcja 'FindLine'
 Szuka w pliku INI danej linii , gdzie jest podany wzorzec i j zwraca
 Parametry wywoania :
  once : 1 gdy chcemy odczyta lini z grup parametrw oddzielonych ','
  pattern : wzorzec wedug ktregp szukamy linii
  line    : znaleziona linia z wzorcem lub NULL gdy nie ma
  termination : 1 gdy chcemy zale lini z nazw sekcji karty
 Rezultat :
  wskanik na pattern
*/
char * FindLine(int once,FILE *ini , char * pattern , char * line,int termination=1)
{															  // szuka w pliku lini gdzie
 char * r;												  // jest wzorzec i zwraca t
 char l[255],c;											  //lini
 int i,ll=0;															  // zwraca wskaznik na pattern
 r = NULL ;
 fpos_t pos;

 if(once!=0)
  {
	while(1)
	 {
	  fgetpos(ini,&pos);
	  fgets(l,255,ini);
	  l[strlen(l)-1]='\0';
	  strupr(l);
	  ll=0;
	  if(l[0]=='\0')
		{
		 continue ;
		}
	  for(i=0;i<strlen(l);i++)
		{
		 c=l[i];
		 if(c>0x20 && c< 0x7F)
		 {
		  if(c==';')
			{
			 ll=1;
			 break;
			}
		 }
		}
	  if(ll==1)
		continue;
	  r = strstr(l,pattern);
	  if(r==NULL)
		fseek(ini,(unsigned long)pos,SEEK_SET);
	  else
	  strcpy(line,l);
	  return(r);
	 }
  }
 while(fgets(l,255,ini)!=NULL)
  {
	 l[strlen(l)-1]='\0';
	 strupr(l);
	 ll=0;
	 for(i=0;i<strlen(l);i++)
	  {
		c=l[i];
		if(c>0x20 && c< 0x7F)
		{
		 if(c==';')
		  {
			ll=1;
			break;
		  }
		}
	  }
	 if(ll==1)
	  continue;
	 r = strstr(l,pattern);
	 if(r!=NULL)
	  {
		strcpy(line,l);
		break ;
	  }
	 else
	  {
		if(termination ==1)
		 {
		  l[strlen(SectionTerm)]='\0';
		  r = strstr(l,SectionTerm);
		  if(r!=NULL) //wyskok z funkcji bo osignito koniec biecej sekcji
			return(NULL) ;
		 }
	  }
  }
  return(r);
}

//////////////////////////////////////////////////////////////////////
// Funkcja FindParam :
// Wybiera parametr z linii podanej linii : 'Opis' = 'param' <- linia
// Parametry wejciowe :
// line : analizowana linia
// param : odczytany marametr
// Rezultat :
// wskanik na odnaleziony parametr
//////////////////////////////////////////////////////////////////////
char * FindParam(char *line , char *param)
{
 char *r = NULL , tab[255],c ;

 r=strpbrk(line,"=");
 if(r!=NULL)
  {
	r++;
	strcpy(param,r);
	int i , j=0 ;
	for(i=0;i<strlen(param);i++)
	 {
	  c=param[i];
	  if(c>0x20 && c< 0x7F)
		{
		 tab[j++]=c;
		}
	 }
	tab[j]='\0';
	strupr(tab);
	strcpy(param,tab);
	r=param;
  }

 return r ;
}

/////////////////////////////////////////////////////////////////
// Funkcja ParamToInt()
// Odczytanie parametru z biecej linii i przeksztacenie do int
// Parametry wejciowe /wy:
//  ini - handler pliku
//  nr - numer stringu z tablicy parametrw  'IniKeyMod'
// *param - przeksztacony do 'int' parametr
// Rezultat
//  LC0_OK lub kod bdu
/////////////////////////////////////////////////////////////////
int ParamToInt(FILE *ini , int nr ,int *param)
{
 char *wsk,*er ;
 char tab[100],line[255];
 int l;
 char err = LC0_OK ;

 wsk=FindLine(0,ini,IniKeyMod[nr],line)  ;
 if(wsk==NULL)
  err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
 else
  {
	wsk=FindParam(line,tab);
	if(wsk==NULL)
	 err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
	else
	 {
	  l = (int)strtol(tab,&er,10);
	  if(er==NULL)
		err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
	  else
		*param = l;
	  }
  }

 return err ;
}

/////////////////////////////////////////////////////////////////////
// Funkcja ParamToTab()
// Odczytanie "count" parametrw numerycznych oddzielonych ','
// Parametry wejciowe :
//  ini - handler pliku
//  nr  - numer parametru w tablicy 'IniKeyMod'
//  count - ilo parametrw do przeksztacenia (odczytu)
//  table - tablica z parametrami przeksztacanymi
//  once -  1
// Rezultat :
//  LC0_OK lub kod bdu .
//////////////////////////////////////////////////////////////////////
int ParamToTab(FILE *ini , int nr ,int count,unsigned int *table,int once)
{
 char *wsk,*er ;
 char tab[100],line[255];
 int l;
 char err = LC0_OK ;

 wsk=FindLine(1,ini,IniKeyMod[nr],line)  ;
 if(wsk==NULL)
  {
	if(once!=0)
	 err= 2 ;
	else
	 err=LC0_BAD_CONFIG ; //bdny plik konfiguracyjny
  }
 else
  {
	wsk=FindParam(line,tab);
	if(wsk==NULL)
	 err= LC0_BAD_CONFIG ;
	else
	 {
		wsk = tab ;
		int i ;
		for(i=0 ; i<count ; i++)
		 {
		  l = (int)strtol(wsk,&er,10);
		  if(*er == '\0' || *er == ',') //separatory
			{
			  if(*er==',')
				wsk = er+1 ;
			  table[i] = l;
			}
		  else
			{
				err= LC0_BAD_CONFIG ;
				break ;
			}

		  if((*er=='\0') && (i<count-3))
			{
			 err= LC0_BAD_CONFIG ;
			 break ;
			}

		 }

	 }

  }
 return err ;
}

//////////////////////////////////////////////////////////////////////
// Funkcja SearchFile()
// szuka pliku AMBEX.INI i go ewentualnie otwiera
// path - nazwa pliku konfiguracyjnego : "AMBEX.INI"
// Rezultat
//  handler do otwartego pliku lub NULL
//////////////////////////////////////////////////////////////////////
FILE* SearchFile(char *path)
{
	char pbuf[144] ;
	UINT wret ;
	FILE *ini ;

	wret = GetWindowsDirectory((LPSTR)pbuf,sizeof(pbuf));
	if(wret!=0)
	 {
	  if(pbuf[wret-1] != '\\')
		strcat(pbuf,"\\");
	  strcat(pbuf,path);
	  ini = fopen(pbuf,"r");
	  if(ini != NULL)
		{
		  //*path = pbuf ;
		  strcpy(path,pbuf);
		  return ini ;
		}
	 }

	 wret = GetSystemDirectory((LPSTR)pbuf,sizeof(pbuf));
	 if(wret!=0)
	 {
	  if(pbuf[wret-1] != '\\')
		strcat(pbuf,"\\");
	  strcat(pbuf,path);
	  ini = fopen(pbuf,"r");
	  if(ini != NULL)
		{
		  strcpy(path,pbuf);
		  return ini ;
		}
	 }

	char *pt;
	pt = searchpath(path);
	if(pt == NULL) //nie znaleziono
	 {
		return NULL ;
	 }
	else
	 {
	  strcpy(path,pt);
	  ini = fopen(path,"r");
	  return ini ;
	 }
}


//////////////////////////////////////////////////////////////////////
// Funkcja ReadIniFile
// Wczytuje parametry globalne dla wszystkich moduw z pliku konfiguracyjnego
// path - scieka do pliku konfiguracyjnego
// position : zwrcona bieca pozycja w pliku konfiguracyjnym (wzkanik odczytu)
// Rezultat :
//  LC0_OK lub kod bdu
//////////////////////////////////////////////////////////////////////
int ReadIniFile(char *path , unsigned long *position)
{
	FILE *ini	;
	char *wsk , line[255],param[255],*er;
	int l ;
	char err = LC0_OK ;
	fpos_t pos;

	ini = SearchFile(path);
	if(ini==NULL)
	 err = LC0_BAD_CONFIG ;
	else
	{
	 wsk = FindLine(0,ini,"[LC-012-1612]",line,0);
	 if(wsk==NULL)
	  err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
	 else
	  {     //okrelenie pozycji sekcji
		 fgetpos(ini,&pos);
		 *position =(unsigned long)pos;
	  }
	 wsk=FindLine(0,ini,IniKeyGlob[0],line)  ;			//PATH
	 if(wsk==NULL)
	  err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
	 else
	  {
		wsk=FindParam(line,param);
		if(wsk==NULL)
		 err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
		else
			strcpy(GData.path,param);
	  }
	 wsk=FindLine(0,ini,IniKeyGlob[1],line)  ;			//INTTIME
	 if(wsk==NULL)
	  err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
	 else
	  {
		wsk=FindParam(line,param);
		if(wsk==NULL)
		  err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
		else
		  {
			l = (int)strtol(param,&er,10);
			if(er==NULL)
			 err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
			else
			 GData.inttime = l;
		  }
	  }
	 wsk=FindLine(0,ini,IniKeyGlob[2],line)  ;			//MODULES
	 if(wsk==NULL)
	  err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
	 else
	  {
		wsk=FindParam(line,param);
		if(wsk==NULL)
			 err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
		else
		  {
			 l = (int)strtol(param,&er,10);
			 if(er==NULL)
			  err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
			 else
			  GData.modules = l;
		  }
	  }
	 // plik na pocztek
	 fseek(ini,0,SEEK_SET);
	 fclose(ini);
	 }
  if(err == LC0_OK)
	GData.globalinit = TRUE ; //tzn. nie ma potrzeby ich ponownego wczytywania
  return err ;
}


///////////////////////////////////////////////////////////////////////////
// Funkcja 'ReadIniModuleAll'
// Odczytuje parametry z pliku konfiguracyjnego (AMBEX.INI) dotyczce wszystkich
// moduw [1]..[4] -> A..D . 'modname'
// przeznaczenie do statycznego adowania przy starcie biblioteki
// path - scieka do pliku INI
// position : pozycja od ktrej naley przeszukiwa plik
// Rezultat :
//  LC0_OK lub kod bedu
//////////////////////////////////////////////////////////////////////////
int ReadIniModuleAll(char *path , unsigned long position)
{
  FILE *ini	;
  char *wsk , line[255];
  int l ;
  char err = LC0_OK ;
  char *num[] = {"[MODULE A]","[MODULE B]","[MODULE C]","[MODULE D]"};
  int count = 1 ;
  unsigned char modname ; //numer moduu
  //int x;

  ini = fopen(path,"r");
  if(ini==NULL)
	 err = LC0_BAD_CONFIG ;
  else
	{
	 fseek(ini,position,SEEK_SET);
	 do
	  {
	  wsk = FindLine(0,ini,num[count-1],line) ;
	  if(wsk==NULL)
		{
		 err = LC0_NO_MODULE ;
		 fseek(ini,position,SEEK_SET);
		}
	  else
		err=LC0_OK;
	  count++ ;
	  modname=count-1;
	  if(err==LC0_OK) //znaleziono waciw sekcj dla wybranego moduu
		{
		 // czytamy poszczeglne parametry , kolejno konieczna
		 while(1)
		  {
			fgets(line,255,ini);

			err = ParamToInt(ini , 1 ,&l) ;   //TCONV
			if(err==LC0_OK)
			 {
				ModWsk[modname-1]->Tconv = l;
			 }
			else
			 break;

			///////////////////////////////////////////////////////////
			err = ParamToTab(ini , 2 ,16,ModWsk[modname-1]->STable,1);
			if(err==2)
			 ModWsk[modname-1]->IsConvtable = 0;
			else
			 {
			  ModWsk[modname-1]->IsConvtable = 1;
			  if(err==LC0_BAD_CONFIG)
				break;
			 }

			err = ParamToInt(ini , 3 ,&l) ; //EXMEM :
			if(err==LC0_OK)
			 {
			  if(l!=0)
				{
				 ModWsk[modname-1]->ExMem = 1;
				 ModWsk[modname-1]->InExSize = (unsigned long int)((unsigned long int)l*1024); //bo w KB
				}
			  else
				{
				 ModWsk[modname-1]->ExMem = 0;
				 ModWsk[modname-1]->InExSize = 0; //bo w KB
				}
			 }
			else
			 break;
			err = ParamToInt(ini , 4 ,&l) ; //MODE : 1 - MASTER reszta - SLAVE
			if(err==LC0_OK)
			 {
			  if(l==1)
				ModWsk[modname-1]->mode = l;
			  else
				ModWsk[modname-1]->mode = 0;
			 }
			else
			 break;

			err = ParamToInt(ini , 5 ,&l) ;   //FREQUENCY MHZ
			if(err==LC0_OK)
			 {
			  if(l==4 || l==8)
				ModWsk[modname-1]->CLK = l;
			  else
				{
				  err = LC0_BAD_CONFIG ;
				  break ;
				}
			 }
			else
			 break;

			err = ParamToInt(ini , 6 ,&l) ;   //IRQ
			if(err==LC0_OK)
			 {
			  if(l==2 || l==3 || l==4 || l==0)
				{
				 ModWsk[modname-1]->IRQ = l;

				 if(l==0)
				  ModWsk[modname-1]->IRQ = 0xff;
				}
			  else
				{
				  err = LC0_BAD_CONFIG ;
				  break ;
				}
			 }
			else
			 break;

			err = ParamToInt(ini , 7 ,&l) ;   //CHANNELS C/A
			if(err==LC0_OK)
			 {
			  if(l==0 || l==1 || l==2)   // l==0 oznacza brak C/A
				ModWsk[modname-1]->CA_channels = l;
			  else
				{
				  err = LC0_BAD_CONFIG ;
				  break ;
				}
			 }
			else
			 break;

			err = ParamToInt(ini , 8 ,&l) ;   //A/C_V1
			if(err==LC0_OK)
			 {
				ModWsk[modname-1]->AC_V1 = l;
			 }
			else
			 break;

			err = ParamToInt(ini , 9 ,&l) ;   //A/C_V2
			if(err==LC0_OK)
			 {
				ModWsk[modname-1]->AC_V2 = l;
			 }
			else
			 break;

			err = ParamToInt(ini , 10 ,&l) ;
			if(err==LC0_OK)
			 {
			  if(l==1 || l==3 || l==0)       //0 - brak DMA
				{
				 ModWsk[modname-1]->AC_DMA = l;
				 // @@@
				 if(l==0)
				  ModWsk[modname-1]->AC_DMA = 0xff;

				}
			  else
				{
				  err = LC0_BAD_CONFIG ;
				  break ;
				}
			 }
			else
			 break;

			if(ModWsk[modname-1]->CA_channels !=0)
			 {
			  err = ParamToInt(ini , 11 ,&l) ;   //C/A1_V1
			  if(err==LC0_OK)
				{
				 ModWsk[modname-1]->CA1_V1 = l;
				}
			  else
				break;
			  err = ParamToInt(ini , 12 ,&l) ;   //C/A1_V2
			  if(err==LC0_OK)
				{
				 ModWsk[modname-1]->CA1_V2 = l;
				}
			  else
				break;
			  if(ModWsk[modname-1]->CA_channels ==2)
				{
				 err = ParamToInt(ini , 13 ,&l) ;   //C/A2_V1
				 if(err==LC0_OK)
				  {
					ModWsk[modname-1]->CA2_V1 = l;
				  }
				 else
				  break;
				 err = ParamToInt(ini , 14 ,&l) ;   //C/A2_V2
				 if(err==LC0_OK)
				  {
					ModWsk[modname-1]->CA2_V2 = l;
				  }
				 else
				  break;
				}
			  err = ParamToInt(ini , 15 ,&l) ;   //C/A_DMA
			  if(err==LC0_OK)
				{
				 if(l==2 || l==3 || l==0)          //0 oznacza brak DMA
				  {
					ModWsk[modname-1]->CA_DMA = l;
					// @@@
					if(l==0)
					 ModWsk[modname-1]->CA_DMA = 0xff;
				  }
				 else
				  {
					err = LC0_BAD_CONFIG ;
					break ;
				  }
				}
			  else
				break;
			  //////////////////////////////////////////////////////////////////
			  err = ParamToTab(ini , 16 ,2,ModWsk[modname-1]->CA_Table,0);
			  if(err!=LC0_OK)
				break;
			 }

		  err = CheckModule(ModWsk[modname-1]->BaseAdr);
		  if(err==LC0_OK)
			{
			 ModWsk[modname-1]->IsLoaded = TRUE ; //zaadowany
			 ModWsk[modname-1]->ClearDACs();
			}
			fseek(ini,position,SEEK_SET);
			break;
		  }
		}
		ModWsk[modname-1]->InitError =err ;
	  }//analizuje bldy
	  while(count<5);
	 fclose(ini);
	}
 return err ;
}

//////////////////////////////////////////////////////////////////////
// Funkcja 'LoadParameters'
// Funkcja adujca dane z pliku AMBEX.INI do pamici
// ustawia pole GData.Error
// Jest wywoywana w LibMain()
//////////////////////////////////////////////////////////////////////
void  LoadParameters(void)
{
  char errcode ;
  unsigned long position;

	strcpy(config_file,ini_file)    ;
	errcode = ReadIniFile(config_file,&position);
	if(errcode != LC0_OK)
	 {
	  GData.Error = errcode ;
	  for(int i=0;i<4;i++)
		{
		 ModWsk[i]->InitError=LC0_BAD_CONFIG;
		}
	  return ;
	 }
  GData.globalinit = TRUE ;
  errcode = ReadIniModuleAll(config_file,position);
  if(errcode==LC0_BAD_CONFIG)
	GData.Error = errcode ;
  else
	GData.Error = LC0_OK ;
}

//////////////////////////////////////////////////////////////////////////
// Funkcja WaitForALevel
// Warunek start od poziomu na wybranym wejciu analogowym
// parametry wejciowe :
//  par[] - tablica z parametrami przetwarzania
//  *errex - dodatkowy kod statusu
//  check - 0 : gdy wywoanie z funkcji LC0_AnalogIn
// Rezultat : kod ststusu
// channel : b0..b5 - nr kanau ;
//			    b6 - 0 - reakcja na zbocze ; 1 - na poziom
//				 b7 - 0 - zbocze opadajce/poniej poziomu
//					   1 - zbocze narastajce/powyej poziomu
// level	: b0..b11 - poziom komparacji wyrazony w kodzie przetwornika
//			: b12..b15 - margines zakce - ilo konwersji A/C na potw. war.startu
//////////////////////////////////////////////////////////////////////////
char WaitForALevel( unsigned char par[],char *errex,int check)
{
 char errcode = LC0_OK ;
 char val ;
 unsigned int level,val16,num,ccount=0 ;
 BOOL type ; //zbocze/poziom
 BOOL value ;//

  *errex = LC0_OK ;
 // adaliza skadni
 if((par[0] >= LC0_MODA) && (par[0]<=LC0_MODD))
  {
	errcode = ModWsk[(int)(par[0])-1]->CheckApp() ;
	if(errcode!=LC0_OK)
	 {
		if(errcode == LC0_NO_MODULE)
		 *errex = LC0_E_NO_MODULE ;
		else
		 *errex = LC0_E_MOD_UNABLE ;
		return LC0_ILL_START ;
	 }

	 if(check==1)
	  if(ModWsk[par[0]-1]->PAC.DevBusy)
		{
		 *errex = LC0_E_MOD_UNABLE ;
		 return LC0_ILL_START ;
		}


	 if(par[1]!=1)
	  {
		*errex = LC0_E_NONEX_DEV ;
		return LC0_ILL_START;
	  }

	 val = par[2] & 0x3f ;
	 if(val == 0x00 || val > AC_CHANNELS) //1.16 OK
	  {
		*errex = LC0_E_BAD_CHAN	;
		return LC0_ILL_START ;
	  }
	 if((par[2] & 0x40) != 0)
	  type = TRUE ;
	 else
	  type = FALSE ;

	 if((par[2] & 0x80) != 0)
	  value = TRUE ;
	 else
	  value = FALSE ;

	//poziom wyzwalania     LSB , MSB
	level = ((unsigned int)par[4]<<8) + (unsigned int)par[3];
	val16 = level & 0x0fff;
	num = level >>12 ;

  }
 else
  {
	 *errex=LC0_E_NO_MODULE ;
	 return LC0_ILL_START ;
  }
 ////////////////////////////////////////////////////////////////////////////
 // akcja - pomiar programowy wybranego kanau analogowego
 ////////////////////////////////////////////////////////////////////////////
 unsigned char mod = par[0]-1 ;
 unsigned int base = ModWsk[mod]->BaseAdr ;
 unsigned int samp,samppop=0 ;
 unsigned char val1,val2;
 BOOL endp=FALSE,first=TRUE ;
 MSG mes ;
 unsigned char norm = ModWsk[mod]->POSTS1 ;
 ModWsk[mod]->Reset();
 outportb(base+ACTC2+3,0xb4);
 outportb(base+ACTC2+2,0x0f);
 outportb(base+ACTC2+2,0x00);
 val1=0x0e ;ModWsk[mod]->POSTS1 = val1;
 outportb(base+ASTS1_W,val1) ;
 outportb(base+AMUX_W,par[2]-1);
 inportb(base+AEN_BLOK_R) ;

 while(1)
  {
	outportb(base+AADC_W,0);
	while(1)
	 {
	  if((inportb(base+ASTS1_R) & 0x80)==0) //-RDY=0
		{
		 val1=inportb(base+AADC_R);
		 val2=inportb(base+AADC_R);
		 samp = (val2 <<8)+ val1 ;
		 if(first)
		  first=FALSE;
		 else
		  {
			if(type==FALSE)
			 {
			  if(value==0)
				{
				 if(samp <= samppop)
				  {
					if(samp!=samppop)
					 ccount ++ ;
					if(ccount > num)
					 {
					  if((samp <= val16)&&(samppop >=val16))
						{
						 endp = TRUE ;
						 break ;
						}
					  ccount = num + 1 ;
					 }
				  }
				 else
				  if(ccount > 0)
					ccount --;
				}
			  else
				{
				  if(samp >= samppop)
					{
					 if(samp!=samppop)
					  ccount ++ ;
					 if(ccount > num)
					 {
					  if((samp >= val16)&&(samppop <= val16))
						{
						 endp = TRUE ;
						 break ;
						}
					  ccount = num + 1 ;
					 }
					}
				  else
					if(ccount >0)
					ccount --;
				}
			 }
			else            //komparator poziomu
			 {
				if(value==0) //poniej poziomu
				 {
				  if(samp <= val16)
					ccount ++ ;
				  else
					ccount = 0;
				 }
				else         //powyej poziomu
				 {
				  if(samp >= val16)
					ccount ++  ;
				  else
					ccount = 0;
				  }
				if(ccount>num)
				 {
				  endp = TRUE ;
				  break ;
				 }
			 }
		  }
		 samppop = samp ;
		 break ;
		}

	  if((inportb(base+ASTS1_R) & 0x40)!=0)
		{
		 errcode = LC0_OVERRUN ;
		 break ;
		}
	  /////////////////////////////////////////////////////
	  // ewentualnie break
	  /////////////////////////////////////////////////////
	  if(ModWsk[mod]->SynEnable) //moliwe przerwanie
		{
		 if(IntBreak(&mes)==FALSE)//przerwano
		  {
			ModWsk[mod]->Reset();
			ModWsk[mod]->MessageBreak();
			*errex = LC0_E_BROKEN_WAIT ;
			errcode = LC0_BROKEN ;
			break ;
		  }
		}
	 }
	if((errcode!= LC0_OK) || (endp == TRUE) )
	 break ;
  }

 ModWsk[mod]->Reset();
 outportb(base + 16 , 0x00) ;
 ModWsk[mod]->Reset();
 ModWsk[mod]->POSTS1 = norm;
 return errcode ;
}

///////////////////////////////////////////////////////////////////////////
// Funkcja WaitForStart()
// Funkcja testujca warunek startu operacji A/C , C/A,Din,Dout
// stst   - typ warunku startu
// par[]  - 4 kolejne parametry unsigned char ze struktury lc0_start
// ptime  - dla typu LC0_STIME warto czasu
// *errex - dodatkowy kod bdu
// MOD    - nr moduu  ktry wywoa funkcj sprawdzania warunkw startu
// check  - 0 gdy wywoanie z funkcji LC0_AnalogIn
// return : kod bdu LC0_STATUS
///////////////////////////////////////////////////////////////////////////
char FAR PASCAL WaitForStart(unsigned char stst , unsigned char par[],
						unsigned long ptime , char *errex,unsigned char MOD,
						int check)
{
  char errcode ;
  BOOL cond = TRUE;
  unsigned char val,nport;
  int modnum ;
  unsigned char mask[] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};
  unsigned char sday[] ={31,28,31,30,31,30,31,31,30,31,30,31};
  unsigned int aport;
  tm *td ;
  time_t t1,t2;
  struct time tt;
  struct date dd;
  MSG mes ;

  BOOL jump = FALSE ;

  *errex = LC0_E_OK ;
  if(stst == LC0_SIMMED)
	return LC0_OK ;
  if(stst == LC0_SHARD )
	return LC0_ILL_START_CODE ;
  if(stst >LC0_SANALOG)
	return LC0_ILL_START_CODE ;

  if(stst == LC0_SANALOG)
	{
	 errcode = WaitForALevel(par,errex,check) ;
	 return errcode ;
	}

  if(stst>=LC0_SLEVEL && stst <=LC0_SDIG_NE) // zwizane z bitami cyfrowymi
	{
	 if(par[0]<LC0_MODA || par[0]>LC0_MODD )
	  {
		*errex = LC0_E_NO_MODULE ;
		return LC0_ILL_START;
	  }
	 errcode = ModWsk[(int)(par[0])-1]->CheckApp() ;
	 if(errcode!=LC0_OK)
	  {
		if(errcode == LC0_NO_MODULE)
		 *errex = LC0_E_NO_MODULE ;
		else
		 *errex = LC0_E_MOD_UNABLE ;
		return LC0_ILL_START ;
	  }

	 if((par[1]==0) || (par[1]>DIN_NUM ))
	  {
		*errex = LC0_E_NONEX_DEV ;
		return LC0_ILL_START;
	  }
	 else
	  {
		nport=par[1];
		switch(nport)
		 {
		  case 1  : aport = ASTS1_R ;
						break;
		  case 2  : aport = DIG_IN_1;
						break;
		  case 3  : aport = DIG_IN_2;
						break;
		 }
	  }

	 if(stst == LC0_SLEVEL || stst == LC0_SSLOPE)
	  {
		 if(nport==1)
		  {
			if((par[2]>4) || (par[2]==0))
			{
				*errex = LC0_E_NONEX_DEV ;
				return LC0_ILL_START;
			}
		  }
		 else    //1-8
		  {
			if((par[2]>8) || (par[2]==0))
			{
				*errex = LC0_E_NONEX_DEV ;
				return LC0_ILL_START;
			}
		  }
	  }
	 else
	  {
		if(nport==1)
		 {
		  par[2]=par[2] & 0x0f ;
		  par[3]=par[3] & 0x0f ;
		 }
		par[3] = par[3] & par[2] ;
	  }
	 /////////////////////////////////////////////////////////////////////////
	 // ptla odczytujca port cyfrowy
	 /////////////////////////////////////////////////////////////////////////
	 modnum = par[0] -1 ;
	 do
	  {
		 if(ModWsk[MOD-1]->SynEnable)
		  {
			 if(IntBreak(&mes)==FALSE)
			  {
				ModWsk[MOD-1]->MessageBreak();
				cond = FALSE ;
				*errex = LC0_E_BROKEN_WAIT ;
				return LC0_BROKEN ;
			  }
		  }

		 val=inportb(ModWsk[modnum]->BaseAdr + aport);
		 if(nport==1)
		  val &=0x0f ;
		 switch(stst)
		  {
			 case	LC0_SLEVEL		:
										 val = val & mask[par[2]-1];
										 if(par[3]==0) //
											{
											 if(val==0)
											  cond=FALSE ; //
											}
										  else         //
											{
											  if(val!=0)
												cond = FALSE ;//
											}
										 break;
			 case	LC0_SSLOPE		:val = val & mask[par[2]-1];
										 if(par[3]!=0)
										  {
											if(!jump)
											 {
												if(val==0)
												 jump = TRUE ;
											 }
											else
											 {
												if(val!=0)
												 cond = FALSE ; //O.K.
											 }
										  }
										 else     // 1->0
										  {
											if(!jump)
											 {
												if(val!=0)
												 jump = TRUE ;
											 }
											else
											 {
												if(val==0)
												 cond = FALSE ; //O.K.
											 }
										  }
										 break;
			 case	LC0_SDIG_EQ		:
			 case	LC0_SDIG_NE		:val = val & par[2] ;//
										 val = val ^ par[3] ;//
										 if(stst==LC0_SDIG_EQ )
											{
											 if(val==0)
											  cond = FALSE ; //O.K. zgadza si
											}
										  else
											{
											 if(val!=0)
											 cond = FALSE ; //O.K.nie zgadza si
											}
										 break;

		  }

	  }while(cond==TRUE);

	 //////////////////////////////////////////////////////////////////////////

	}
  else                                       //zwizane z czasem
	{
	  if(stst==LC0_SDATE)
		{
		  if((par[0]>=60)||(par[1]>=60)||(par[2]>=24))
			{
			  *errex = LC0_E_BAD_TIME ;
			  return LC0_ILL_START ;
			}
		  //dzie miesica
		  t1=time(NULL);
		  td = gmtime(&t1);
		  if(par[3]>sday[td->tm_mon])
			{
			  *errex = LC0_E_BAD_DATE ;
			  return LC0_ILL_START ;
			}
		}
	  //////////////////////////////////////////////////////////////////
	  // ptla sprawdzajca  czas
	  //////////////////////////////////////////////////////////////////
	  t1=time(NULL);
	  do
		{
		 if(ModWsk[MOD-1]->SynEnable)
		  {
			 if(IntBreak(&mes)==FALSE)
			  {
				ModWsk[MOD-1]->MessageBreak();
				cond = FALSE ;
				*errex = LC0_E_BROKEN_WAIT ;
				return LC0_BROKEN ;
			  }
		  }

		 t2=time(NULL);
		 if(stst==LC0_STIME) //
		  {
			 if(difftime(t2,t1)>=ptime)
			  {
				cond = FALSE ;
			  }
		  }
		 else               //
		  {
			 getdate(&dd);
			 gettime(&tt);
			 if((dd.da_day==par[3]) && (tt.ti_hour==par[2]) && (tt.ti_min==par[1])
			 && (tt.ti_sec==par[0]))
				{
				  cond = FALSE ;
				}
		  }
		}while(cond==TRUE);
	}

 return LC0_OK ;
}

///////////////////////////////////////////////////////////////////////////////
// Funkcja IntBreak
// Wewntrzna procedura monitorowania warunkw startu i operacji synchronicznych
// Wejcie : wskaznik do struktury opisu komunikatu
// Wyjcie : TRUE gdy nie przerwana FALSE - przerwanie
////////////////////////////////////////////////////////////////////////////////
BOOL IntBreak(MSG *mes)
{

 if(GetAsyncKeyState(KEYBREAK1)& 0x8000)
  {
	 while(::PeekMessage(mes,NULL,WM_KEYFIRST,WM_KEYLAST,PM_REMOVE|PM_NOYIELD))
	 {
		 //i++;
	 }
	 while(::PeekMessage(mes,NULL,WM_MOUSEFIRST,WM_MOUSELAST,PM_REMOVE|PM_NOYIELD))
	 {
		 //i++;
	 }
	  return FALSE ;
	}
  return TRUE ;
}

////////////////////////////////////////////////////////////////////////
// Funkcja dividers()
// value[32] = *div1**div2
////////////////////////////////////////////////////////////////////////
void dividers(unsigned long value, unsigned int *div1,unsigned int *div2)
{
 long temp;
 int rest,trest,tdiv1,tdiv2,r;

 *div2 = 1;
 do {(*div2)++ ; temp=value / *div2 ;}while(temp>0xFFFFL);
 *div1 = (UINT)temp ;
 rest = (int)(value - (*div1)*(*div2));
 r=abs((int)(value-((*div1) +1)* (*div2)));
 rest = rest < r ? rest : (*div1)++,r ;
 trest = rest;tdiv1=*div1;tdiv2=*div2 ;
 while((trest!=0) && (tdiv1>tdiv2))
  {
	 tdiv2++;
	 tdiv1=(UINT)(value/tdiv2);
	 trest=(int)(value - tdiv1*tdiv2) ;
	 r=abs((int)(value-(tdiv1+1)*tdiv2));
	 trest = trest < r ? trest : tdiv1++ ,r;
	 if(trest<rest)
	  {
		rest = trest;
		*div1=tdiv1;
		*div2=tdiv2;
	  }
  }
}


/////////////////////////////////////////////////////////////////////////
// obsuga wewntrznego bufora DMA wsplnego dla wszystkich moduw
// rzeczy nie uzywane
/////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// alokacja i zwolnienie pamici wewntrznego bufora DMA
////////////////////////////////////////////////////////////////////////////////
// UWAGA !!! Gdy sukces ustawia zmienn GData.DMAError = LC0_OK lub na
// odpowiedni warto przy bdzie : LC0_NOT_INIT
// !!! Funkcja nie uywana .
////////////////////////////////////////////////////////////////////////////////
void AllocDMABuffer()
{

}

/////////////////////////////////////////////////////////////
// Zwolnienie zaalokowanego bufora DMA
// Funkcja nie uywana
/////////////////////////////////////////////////////////////
void FreeDMABuffer()
{

}


////////////////////////////////////////////////////////////////////////////
// funkcja dokonujca transferu danych pomidzy wsplnym dla wszystkich
// moduw buforem pamici liniowej dla DMA a buforami uytkowymi (pam.rozszerzonej
// lub programowy) konkretnego moduu . Przeznaczenie do obsugi wewntrznych transferw
// w sekcjach trybu pracy blokowej DMA funkcji LC0_AnalogIn i LC0_AnalogOut
// !!! Wane
// Nie jest sprawdzana skadnia ani poprawno parametrw bo si to robi w fukcjach API DLL.
///////////////////////////////////////////////////////////////////////////////
char DMAToClientTransfer(DMA_transmit *param)
{
	if((GData.DMAError!=LC0_OK) || (GData.ptrbuf==NULL)  )
	 return GData.DMAError ; //bd twardy

	unsigned long i ;
	int huge *ptr	 ;
	int huge *dptr  ;
	dptr = (int huge *)(GData.ptrbuf) ;
	if(param->Client==LC0_EXTMEM)
	 ptr = ModWsk[(param->module) -1 ]->ptrex ;
	else
	 ptr = (int huge *)(param->ProgBuf);

	if(param->direction == LC0_FROM_DMA)
	 {
		for(i=0;i<param->samples;i++)
		 *(ptr+(param->ClientOffset)+i)=*(dptr + (param->DMAOffset)+i);
	 }
	else
	 {
		for(i=0;i<param->samples;i++)
		 *(dptr + (param->DMAOffset)+i)=*(ptr+(param->ClientOffset)+i);
	 }
	return LC0_OK ;
}

//////////////////////////////////////////////////////////////////////////
// Funkcja CheckModule()
// Test obecnoci moduu LC-012-1612 pod adresem bazowym 'badr'
// Rezultat : LC0_OK lub kod bdu
//////////////////////////////////////////////////////////////////////////
char CheckModule(unsigned int badr)
{
 unsigned char POSTS1 = 0xff;
 unsigned char val1;
 POSTS1 = 0x0e ;
 outportb(badr + 12,0x0e);
 outportb(badr + 13,0xbf);
 outportb(badr + 16 , 0x00) ;
 outportb(badr+3,0x34)	;
 outportb(badr+3,0x74)	;
 outportb(badr+7,0x32)	;
 outportb(badr+4,0x18)	;
 outportb(badr+4,0x00)  ;
 outportb(badr+7,0x72)	;
 outportb(badr+5,0x18)	;
 outportb(badr+5,0x00)  ;
 outportb(badr+7,0xb4)	;
 outportb(badr+6,0x10)	;
 outportb(badr+6,0x00)	;

 outportb(badr+3,0x34);
 outportb(badr,0x10)	; //
 outportb(badr,0x10)	; //
 outportb(badr+3,0x74); //
 outportb(badr+1,0x10); //
 outportb(badr+1,0x10); //
 outportb(badr+3,0xb4); //
 outportb(badr+2,0x10); //
 outportb(badr+2,0x10); //
 POSTS1 &= 0x7f ;
 outportb(badr + 12 , 0x7f) ;
 POSTS1 |= 0x80 ;
 outportb(badr + 12 , POSTS1) ;
 POSTS1 &= 0x7f ;
 outportb(badr + 12 , POSTS1) ;

 int i;

 int period = 30000 ;
 char err = LC0_NO_MODULE ;
 outportb(badr+ACTC1+3,0x34);
 outportb(badr+ACTC1,0x10);
 outportb(badr+ACTC1,0x10);

 outportb(badr+ACTC1+3,0x74);
 outportb(badr+ACTC1+1,0x10);
 outportb(badr+ACTC1+1,0x10);
 outportb(badr+ACTC2+3,0xb4);
 outportb(badr+ACTC2+2,0x0f);
 outportb(badr+ACTC2+2,0x00);
 val1=0x0e ;
 outportb(badr+ASTS1_W,val1) ;
 outportb(badr+AMUX_W,1);
 inportb(badr+AEN_BLOK_R) ;

 outportb(badr+AADC_W,0);
 outportb(badr+AADC_W,0);
		for(i=0;i<period;i++)
		 {
		  if((inportb(badr+ASTS1_R) & 0x80)==0)
			{
				inportb(badr+AADC_R);
				inportb(badr+AADC_R);
				err = LC0_OK ;
				break ;
			}
		 }

 POSTS1 &= 0x7f ;
 outportb(badr + 12 , 0x7f) ;
 POSTS1 |= 0x80 ;
 outportb(badr + 12 , POSTS1) ;
 POSTS1 &= 0x7f ;
 outportb(badr + 12 , POSTS1) ;
 return(err) ;
}

/////////////////////////////////////////////////////////////////////////
// Funkcja ProgDMA8
// Programowanie kanaw 8-o bitowych DMA 8037A
// kanal - nr kanalu 0..3
// tryb	- 1 - single ; 0-block
// cykl	- 1 - b.cykliczny
// zapis	- 1 - zapis do portu ; 0 - odczyt z portu
// il_b	- ilo bajtw transmisji < 64K
// fadres - adres fizyczny 32-bitowy pocztku bufora
// zwraca warto rejestru strony DMA
/////////////////////////////////////////////////////////////////////////
unsigned char ProgDMA8(int kanal , int tryb , int cykl , int zapis , unsigned int il_b ,
				  unsigned long int fadres)
{
  unsigned  LicznAdrKan    ;
	unsigned  LicznTransmisji ;
	unsigned  RejStrony 	;

	unsigned int RejRozk	;
	unsigned int RejMaskiKan	;
	unsigned int RejTrybu	;
	unsigned int MasterFlipFlop ;
	unsigned char value,c	;
	unsigned int  adres		;
	unsigned char strona		;
	unsigned long real_adr 	;
	unsigned char xxx[10];
	unsigned char maska[]={1,2,4,8,16,32,64,128};
	int j=0,i;

	MasterFlipFlop = 0x0c ;
	RejRozk	  		= 0x08 ;
	RejMaskiKan		= 0x0a ;
	RejTrybu	  		= 0x0b ;

	real_adr = fadres;
	value = 0;
	if(tryb==1)
	 value = 0x40 ;
	else
	 value = 0x80 ;
	if(cykl==1)
	 value = value | maska[4]  ;
	if(zapis==1)
	 value = value | maska[3]  ;
	else
	 value = value | maska[2]  ;
	outportb(RejRozk,0x00);
	switch (kanal)
	 {
		case  0		: 	LicznAdrKan     = 0x00 ;
							LicznTransmisji = 0x01 ;
							RejStrony	  = 0x87 ;
							outportb(RejMaskiKan,0x04) ;
							value = value ;
							break;
		case  1		: 	LicznAdrKan     = 0x02 ;
							LicznTransmisji = 0x03 ;
							RejStrony	  = 0x83 ;
							outportb(RejMaskiKan,0x05) ;
							value = value | maska[0];
							break;
		case  2		: 	LicznAdrKan     = 0x04 ;
							LicznTransmisji = 0x05 ;
							RejStrony	  = 0x81 ;
							outportb(RejMaskiKan,0x06) ;
							value = value | maska[1];
							break;
		case  3		: 	LicznAdrKan     = 0x06 ;
							LicznTransmisji = 0x07 ;
							RejStrony	  = 0x82 ;
							outportb(RejMaskiKan,0x07) ;
							value = value | maska[0];
							value = value | maska[1];
							break;
	 };
	for(i =0 ; i<100 ;i++)
	  j++;
	outportb(RejTrybu,value) ;

  adres=(unsigned int)(real_adr & 0x00ffff);
  strona=(unsigned char)((real_adr & 0xff0000) >> 16) ;
  real_adr = ((unsigned long)adres ) | ((unsigned long)strona << 16);

  xxx[0] = (unsigned char)(adres & 0x00ff);
  xxx[1] = (unsigned char)((adres >> 8) & 0x00ff);
  xxx[2] = (unsigned char)(il_b & 0x00ff);
  xxx[3] = (unsigned char)((il_b >> 8) & 0xff);


  outportb(MasterFlipFlop,0xff);
  outportb(LicznTransmisji,xxx[2]) ;
  outportb(LicznTransmisji,xxx[3]);


  outportb(RejStrony,strona) ;
  outportb(MasterFlipFlop,0xff);
  outportb(LicznAdrKan,xxx[0]);
  outportb(LicznAdrKan,xxx[1]);

  c=(unsigned char)kanal ;
  outportb(RejMaskiKan,c);
  return(strona);
}

//////////////////////////////////////////////////////////////////////////////
// Funkcja disableDMA8
// Zablokowanie wybranego kanau DMA na czas programowania
//////////////////////////////////////////////////////////////////////////////
void disableDMA8(int kanal)
 {
	unsigned RejMaskiKan = 0x0a ;

	 switch(kanal)
	  {
		 case 0	 :outportb(RejMaskiKan,0x04) ;
					  break;
		 case 1   :outportb(RejMaskiKan,0x05) ;
					  break;
		 case 2	 :outportb(RejMaskiKan,0x06) ;
					  break ;
		 case 3	 :outportb(RejMaskiKan,0x07) ;
					  break ;
	  };
 }

////////////////////////////////////////////////////////////////////////////
// Funkcja WaitForEndAC :
// oczekiwanie na koniec transmisji DMA
// zwraca odpowiedni kod bdu : LC0_OVERRUN , LC0_BROKEN (=> RUN) lub LC0_OK
// Parametry :
// WEP.strona : nr strony DMA przy pierwszym zaprogramowaniu
// WEP.nst	 : liczba segmentw danych do zgromadzenia == ilo przeprogramowa r.stron
// WEP.est	 : liczba b. ostatniej transmisji : do liczn. transmisji wpisa =-1 gdy != 0
// WEP.modnum : nr moduu
// ARMNUM : wskanik do LC0_ARMNUM
// WEP.page   : 0 - tryb bez gubienia prbek ; 1- z gubieniem
// sprawdza wcinicie CTRL-BREAK
// base : adres bazowy moduu
// kanDMA : numer kanau DMA
// v3 .. v4 - parametry pomocnicze
// shard : 1 gdy start sprztowy
// Rezultat :
//  LC0_OK lub kod bdu
////////////////////////////////////////////////////////////////////////////
char WaitForEndAC(unsigned char strona,
						unsigned int nst	  ,
						unsigned int est	  ,
						unsigned char page,
						unsigned int st,
						unsigned char kanDMA,
						unsigned char LicznTransmisji,
						unsigned char RejStrony,
						unsigned char v3,
						unsigned char v4,
						unsigned int base,
						BOOL shard,
						unsigned long int *ARMNUM)
{
 char errcode = LC0_OK;
 unsigned int  x;
 unsigned char v1=0xff,v2=0xff ;
 MSG mes ;
 unsigned int bxx = base+ASTS1_W;
 outportb(base+ASTS1_W,ModPtrAC->POSTS1);

 if(!shard)
  inportb(base+AEN_BLOK_R);
  while(1)
	{
	 if((inportb(0x08) & maska[kanDMA]) != 0)
	  {
		if(nst==0)
		 {
		  outportb(bxx,0x0e);
		  ModPtrAC->POSTS1 = 0x0e ;
		  break ;
		 }
		else
		 {
		  if(st==nst)
			{
			 outportb(bxx,0x0e);
			 ModPtrAC->POSTS1 = 0x0e ;
			 break ;
			}
		  outportb(0x0a,4+kanDMA) ;
		  if(page!=0)
			{
			  outportb(base+ASTS1_W,(ModPtrAC->POSTS1) & 0xef );
			}
		  strona++;
		  st++;
		  outportb(RejStrony,strona);
		  if(st==nst)
			{
			 v1=v3;
			 v2=v4;
			}
		  outportb(0x0c,0xff);
		  outportb(LicznTransmisji,v1) ;
		  outportb(LicznTransmisji,v2);
		  outportb(0x0a,kanDMA);
		  if(page!=0)
			{
			 outportb(base+ASTS1_W,(ModPtrAC->POSTS1) | 0x10 );
			 inportb(base+AEN_BLOK_R);
			}
		  continue ;
		 }
	  }
	 if((inportb(base+ASTS1_R) & 0x40) !=0 )
	  {
		outportb(bxx,0x0e);
		ModPtrAC->POSTS1 = 0x0e ;
		errcode = LC0_OVERRUN ;
		break ;
	  }

	 if(ModPtrAC->SynEnable)
	  {
		if(ModPtrAC->AsyncEnable==0)
		 {
		  outportb(bxx,0x0e);
		  ModPtrAC->POSTS1 = 0x0e ;
		  ModPtrAC->AsyncEnable=1;
		  errcode = LC0_BROKEN ;
		  break ;
		  }
		if(IntBreak(&mes)==FALSE)
		 {
		  outportb(bxx,0x0e);
		  ModPtrAC->POSTS1 = 0x0e ;
		  errcode = LC0_BROKEN ;
		  break ;
		 }
	  }
	}

 outportb(base + 16 , 0x00) ;
 ModPtrAC->Reset();
 v1=v2=0;
 outportb(0x0c,0xff);
 v1=inportb(LicznTransmisji);
 v2=inportb(LicznTransmisji);

 x=(v2<<8) + v1 ;
 if((nst==0) || (st==nst))
  x = est -x ;
 else
  if(st<nst)
	x = (unsigned int)65535 - x ;
 *ARMNUM = st*32768 + x/2 ;
 return(errcode);

}


////////////////////////////////////////////////////////////////////////////
// Funkcja WaitForEndCA()
// Oczekiwanie na koniec transmisji DMA dla funkcji Analog_Output
// zwraca odpowiedni kod bdu : LC0_BROKEN (=> RUN) lub LC0_OK .
// Parametry :
// WEP.strona : nr strony DMA przy pierwszym zaprogramowaniu
// WEP.nst	 : liczba segmentw danych do zgromadzenia == ilo przeprogramowa r.stron
// WEP.est	 : liczba b. ostatniej transmisji : do liczn. transmisji wpisa =-1 gdy != 0
// v3 , v4   : parametry pomocnicze
// base      : adres bazowy moduu
// WEP.modnum : nr moduu
// WEP.NRMNUM : wskanik do LC0_NRMNUM
// WEP.cykl	 : 1 - oznacza prac z b. cyklicznym DMA gdy il. prbek <32K
// sprawdza wcinicie CTRL-BREAK
////////////////////////////////////////////////////////////////////////////
char WaitForEndCA(unsigned char strona,
						unsigned int nst	  ,
						unsigned int est	  ,
						unsigned int st,
						unsigned char kanDMA,
						unsigned char LicznTransmisji,
						unsigned char RejStrony,
						unsigned char v3,
						unsigned char v4,
						unsigned int base,
						int cykl,
						unsigned long int *NRMNUM)
{
 char errcode = LC0_OK;
 unsigned int  x;
 unsigned char v1=0xff,v2=0xff ;
 MSG mes ;
 unsigned int bxx = base+ASTS1_W;
  if(cykl==0)
	{
	 while(1)
	  {
		if((inportb(0x08) & maska[kanDMA]) != 0)
		 {
		  if(nst==0)
			{
			 outportb(bxx,0x0e);
			 ModPtrCA->POSTS1 = 0x0e ;
			 break ;
			}
		  else
			{
			 if(st==nst)
			  {
				outportb(bxx,0x0e);
				ModPtrCA->POSTS1 = 0x0e ;
				break ;
			  }
			 outportb(0x0a,4+kanDMA) ;
			 strona++;
			 st++;
			 outportb(RejStrony,strona);
			 if(st==nst)
			  {
				v1=v3;
				v2=v4;
			  }
			 outportb(0x0c,0xff);
			 outportb(LicznTransmisji,v1) ;
			 outportb(LicznTransmisji,v2);
			 outportb(0x0a,kanDMA);
			 continue ;
			}
		 }

		if(ModPtrCA->SynEnable)
		 {
		  if(ModPtrCA->AsyncEnable==0)
			{
			 outportb(bxx,0x0e);
			 ModPtrCA->POSTS1 = 0x0e ;
			 ModPtrCA->AsyncEnable=1;
			 errcode = LC0_BROKEN ;
			 break ;
			}
		  if(IntBreak(&mes)==FALSE)
			{
			 outportb(bxx,0x0e);
			 ModPtrCA->POSTS1 = 0x0e ;
			 errcode = LC0_BROKEN ;
			 break ;
			}
		 }
	  }
	 }
	else
	 {
	  while(1)
		{
		 if(ModPtrCA->AsyncEnable==0)
			{
			 outportb(bxx,0x0e);
			 ModPtrCA->POSTS1 = 0x0e ;
			 ModPtrCA->AsyncEnable=1;
			 errcode = LC0_BROKEN ;
			 break ;
			}
		 if(IntBreak(&mes)==FALSE)
		  {
			outportb(bxx,0x0e);
			ModPtrCA->POSTS1 = 0x0e ;
			errcode = LC0_BROKEN ;
			break ;
		  }
		}
	 }

 outportb(base + 16 , 0x00) ;
 ModPtrCA->Reset();

 outportb(0x0c,0xff);
 v1=inportb(LicznTransmisji);
 v2=inportb(LicznTransmisji);
 x=(v2<<8) + v1 ;
 if((nst==0) || (st==nst))
  x = est -x ;
 else
  if(st<nst)
	x = (unsigned int)65535 - x ;
 *NRMNUM = st*32768 + x/2 ;
 return(errcode);
}



